#version 430 core

in vec2 textCoord;

out vec4 Color;

uniform vec2 offset;
layout(binding = 0)uniform sampler2D image;
uniform bool horizontal;
uniform float weight[5] = float[](0.227027, 0.1945946, 0.1216216, 0.054054, 0.016216);

vec3 blur(vec2 value) {
	vec3 sum = texture(image, textCoord).rgb * weight[0];
	
	for(int i = 1; i < 5; i++) {
		sum += texture(image, textCoord + value * i).rgb * weight[i];
		sum += texture(image, textCoord - value * i).rgb * weight[i];
	}
	
	return sum;
}

void main(void) {
	//vec2 offset = 1.0/textureSize(image, 0);
	vec3 result = vec3(0);
	
	if(horizontal) {
		result = blur(vec2(offset.x, 0.0));
	}
	else
		result = blur(vec2(0.0, offset.y));
		
	Color = vec4(result, 1);
}