#version 430 core

layout(location = 0) in vec3 position;
layout(location = 1) in vec3 normal;
layout(location = 2) in vec2 uv;
layout(location = 3) in vec3 tangent;
layout(location = 4) in vec3 bitangent;


out VertexData {
	vec3 position_world;
	vec3 normal_world;
	vec2 uvTexCoord;
	mat3 tbn;
} vert;

uniform mat4 modelMatrix;
uniform mat4 viewProjMatrix;
uniform mat3 normalMatrix;

void main() {
	vec4 position_world_ = modelMatrix * vec4(position, 1);
	vert.position_world = position_world_.xyz;
	vert.uvTexCoord = uv;
	
	vec3 t = normalize(normalMatrix * tangent);
	vec3 n = normalize(normalMatrix * normal);
	t = normalize( t - dot(t,n)*n);
	vec3 b = cross(n,t);
	
	vert.tbn = mat3(t,b,n);
	
	vert.normal_world = n;
	
	gl_Position = viewProjMatrix * position_world_;
}